/// <reference path="C:\Users\RUI\OneDrive\lib\aftereffects.d.ts\ae.d.ts"/>
(function () {
    var isCompActive = function (comp) {
        if (!(comp && comp instanceof CompItem)) {
            return false;
        }
        else {
            return true;
        }
    };
    var isLayerSelected = function (layers) {
        if (layers.length === 0) {
            return false;
        }
        else {
            return true;
        }
    };
    var main = function () {
        var actComp = app.project.activeItem;
        if (!isCompActive(actComp)) {
            return 0;
        }
        var selLayers = actComp.selectedLayers;
        var soloValue = false;
        var sameAllValue = true;
        if (isLayerSelected(selLayers)) {
            soloValue = selLayers[selLayers.length - 1].solo;
            for (var i = 0; i < selLayers.length; i++) {
                if (selLayers[i].solo != soloValue) {
                    sameAllValue = false;
                    break;
                }
            }
            if (sameAllValue) {
                soloValue = !soloValue;
            }
            for (var i = 0; i < selLayers.length; i++) {
                selLayers[i].solo = soloValue;
            }
        }
        else {
            for (var i = 1; i <= actComp.layers.length; i++) {
                actComp.layer(i).solo = !actComp.layer(i).solo;
            }
        }
        return 0;
    };
    app.beginUndoGroup("Reverse Solo");
    main();
    app.endUndoGroup();
    return 0;
}).call(this);
